uniform float Param;
varying vec3 lightDir;
varying vec3 halfVector;

void main()
{
	gl_TexCoord[0] = gl_MultiTexCoord0;		//Material of object 1 coordinates
	gl_TexCoord[1] = gl_MultiTexCoord1;		//Material of object 2 coordinates
	//gl_TexCoord[2] = gl_MultiTexCoord2;		//Detail Texture of object 1 coordinates
	//gl_TexCoord[3] = gl_MultiTexCoord3;		//Detail Texture of object 2 coordinates

	//Calculate new interpolated world pos
	vec4 worldPos = gl_Vertex + vec4(gl_MultiTexCoord4.xyz,0.0)*Param;
	vec3 aux;	
    
      //Calculate the TBN matrix
   	vec3 n = gl_NormalMatrix * (gl_Normal + gl_Color.xyz*Param);
	vec3 t = gl_NormalMatrix * (gl_MultiTexCoord2.xyz + gl_MultiTexCoord3.xyz * Param);
	vec3 b = cross(n,t);		

	if( gl_LightSource[0].position.w > 0.0 )		//Point Light
		aux = (gl_LightSource[0].position - worldPos).xyz;
	else							//Directional Light
		aux = normalize(gl_LightSource[0].position.xyz);
	
	//Transform light space to targent space
	lightDir.x = dot(aux,t);
	lightDir.y = dot(aux,b);
	lightDir.z = dot(aux,n);

	halfVector = normalize(gl_LightSource[0].halfVector.xyz);

	halfVector.x = dot(halfVector,t);
	halfVector.y = dot(halfVector,b);
	halfVector.z = dot(halfVector,n);

	gl_Position = gl_ModelViewProjectionMatrix * worldPos; 
} 

